*
*  libflame
*  An object-based infrastructure for developing high-performance
*  dense linear algebra libraries.
*
*  Copyright (C) 2009, The University of Texas
*
*  libflame is free software; you can redistribute it and/or modify
*  it under the terms of the GNU Lesser General Public License as
*  published by the Free Software Foundation; either version 2.1 of
*  the License, or (at your option) any later version.
*
*  libflame is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
*  Lesser General Public License for more details.
*
*  You should have received a copy of the GNU Lesser General Public
*  License along with libflame; if you did not receive a copy, see
*  http://www.gnu.org/licenses/.
*
*  For more information, please contact us at flame@cs.utexas.edu or
*  send mail to:
*
*  Field G. Van Zee and/or
*  Robert A. van de Geijn
*  The University of Texas at Austin
*  Department of Computer Sciences
*  1 University Station C0500
*  Austin TX 78712
*

      INTEGER TRUE, FALSE
      PARAMETER ( TRUE = 1, FALSE = 0 )

      INTEGER NULL
      PARAMETER ( NULL = 0 )
*
*     WARNING: If any of the values below are changed, the corresponding
*     C definitions may need to be changed in FLA_macro_defs.h as well! 
*
      INTEGER FLA_SUCCESS, FLA_FAILURE 
      PARAMETER ( FLA_SUCCESS = 0, FLA_FAILURE = -1 )

      INTEGER FLA_TL, FLA_TR, FLA_BL, FLA_BR
      PARAMETER ( FLA_TL = 11, FLA_TR = 12, FLA_BL = 21, FLA_BR = 22 )

      INTEGER FLA_FLOAT, FLA_DOUBLE, FLA_COMPLEX, FLA_DOUBLE_COMPLEX,
     $        FLA_INT, FLA_CONSTANT, FLA_OBJ
      PARAMETER ( FLA_FLOAT = 100, FLA_DOUBLE = 101, 
     $            FLA_COMPLEX = 102, FLA_DOUBLE_COMPLEX = 103,
     $            FLA_INT = 104, FLA_CONSTANT = 105,
     $            FLA_OBJ = 106 )

      INTEGER FLA_TOP, FLA_BOTTOM, FLA_LEFT, FLA_RIGHT
      PARAMETER ( FLA_TOP = 200, FLA_BOTTOM = 201,
     $            FLA_LEFT = 210, FLA_RIGHT = 211 )

      INTEGER FLA_LOWER_TRIANGULAR, FLA_UPPER_TRIANGULAR
      PARAMETER ( FLA_LOWER_TRIANGULAR = 300, 
     $            FLA_UPPER_TRIANGULAR = 301 )

      INTEGER FLA_NO_TRANSPOSE, FLA_TRANSPOSE, FLA_CONJ_TRANSPOSE,
     $        FLA_CONJ_NO_TRANSPOSE
      PARAMETER ( FLA_NO_TRANSPOSE = 400, FLA_TRANSPOSE = 401,
     $            FLA_CONJ_TRANSPOSE = 402, 
     $            FLA_CONJ_NO_TRANSPOSE = 403 )

      INTEGER FLA_CONJUGATE, FLA_NO_CONJUGATE
      PARAMETER ( FLA_NO_CONJUGATE = 450, FLA_CONJUGATE = 451 )

      INTEGER FLA_UNIT_DIAG, FLA_NONUNIT_DIAG, FLA_ZERO_DIAG
      PARAMETER ( FLA_UNIT_DIAG = 500, FLA_NONUNIT_DIAG = 501,
     $            FLA_ZERO_DIAG = 502 )

      INTEGER FLA_DIMENSION_M, FLA_DIMENSION_K, FLA_DIMENSION_N,
     $        FLA_DIMENSION_MIN
      PARAMETER ( FLA_DIMENSION_M = 600, FLA_DIMENSION_K = 601,
     $            FLA_DIMENSION_N = 602, FLA_DIMENSION_MIN = 603 )

      INTEGER FLA_NATIVE_PIVOTS, FLA_LAPACK_PIVOTS
      PARAMETER ( FLA_NATIVE_PIVOTS = 700, FLA_LAPACK_PIVOTS = 701 )

      INTEGER FLA_FORWARD, FLA_BACKWARD
      PARAMETER ( FLA_FORWARD = 800, FLA_BACKWARD = 801 )

      INTEGER FLA_COLUMNWISE, FLA_ROWWISE
      PARAMETER ( FLA_COLUMNWISE = 900, FLA_ROWWISE = 901 )

*
*     This variable is initialized to some value that we know will be
*     sufficiently large to hold the true size of an FLA_Obj.
*
*     The name FLA_OBJ_SIZE is misleading. This is actually the 4-byte
*     word length of arrays that are used as FLAME objects in Fortran
*     settings.
*
      INTEGER FLA_OBJ_SIZE
      PARAMETER ( FLA_OBJ_SIZE = 20 )

      INTEGER FLA_MINUS_ONE( FLA_OBJ_SIZE )
      INTEGER FLA_ZERO( FLA_OBJ_SIZE )
      INTEGER FLA_ONE( FLA_OBJ_SIZE )
      INTEGER FLA_TWO( FLA_OBJ_SIZE )

      COMMON / FLA_CONSTANTS / FLA_MINUS_ONE, FLA_ZERO, FLA_ONE, FLA_TWO

