/*
   libflame
   An object-based infrastructure for developing high-performance
   dense linear algebra libraries.

   Copyright (C) 2009, The University of Texas

   libflame is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 2.1 of
   the License, or (at your option) any later version.

   libflame is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with libflame; if you did not receive a copy, see
   http://www.gnu.org/licenses/.

   For more information, please contact us at flame@cs.utexas.edu or
   send mail to:

   Field G. Van Zee and/or
   Robert A. van de Geijn
   The University of Texas at Austin
   Department of Computer Sciences
   1 University Station C0500
   Austin TX 78712
*/

#ifndef FLASH_TYPE_DEFS_H
#define FLASH_TYPE_DEFS_H


typedef struct FLASH_Obj_queue_s FLASH_Obj_queue;
typedef struct FLASH_Obj_task_s  FLASH_Obj_task;


struct FLASH_Obj_queue_s
{
      // Number of tasks currently in queue
      int             n_tasks;

      // Pointers to head (front) and tail (back) of queue
      FLASH_Obj_task* head;
      FLASH_Obj_task* tail;
};


struct FLASH_Obj_task_s
{
      // Axpy and Copy
      int             direction;      
      FLA_Obj         alpha;

      // Flat matrix
      FLA_Obj         F; 

      // Hierarchical matrix
      FLA_Obj         H;

      // Support for a doubly linked list of tasks
      FLASH_Obj_task* prev_task;
      FLASH_Obj_task* next_task;
};


#endif
