/*
   libflame
   An object-based infrastructure for developing high-performance
   dense linear algebra libraries.

   Copyright (C) 2009, The University of Texas

   libflame is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 2.1 of
   the License, or (at your option) any later version.

   libflame is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with libflame; if you did not receive a copy, see
   http://www.gnu.org/licenses/.

   For more information, please contact us at flame@cs.utexas.edu or
   send mail to:

   Field G. Van Zee and/or
   Robert A. van de Geijn
   The University of Texas at Austin
   Department of Computer Sciences
   1 University Station C0500
   Austin TX 78712
*/

// Internal initialization-related routines
#define fla_init_fortran FLA_INIT_FORTRAN
#define fla_finalize_fortran FLA_FINALIZE_FORTRAN
#define fla_obj_datatype_size_f FLA_OBJ_DATATYPE_SIZE_F

// Internal dot wrappers
#define fla_cdotc FLA_CDOTC
#define fla_zdotc FLA_ZDOTC
#define fla_cdotu FLA_CDOTU
#define fla_zdotu FLA_ZDOTU

// Internal LAPACK-like routines
#define cgelq2ut CGELQ2UT
#define cgelqfut CGELQFUT
#define cgeqr2ut CGEQR2UT
#define cgeqrfut CGEQRFUT
#define cgetn2 CGETN2
#define cgetnf CGETNF
#define clarfbut CLARFBUT
#define clarfgut CLARFGUT
#define clarftut CLARFTUT
#define dgelq2ut DGELQ2UT
#define dgelqfut DGELQFUT
#define dgeqr2ut DGEQR2UT
#define dgeqrfut DGEQRFUT
#define dgetn2 DGETN2
#define dgetnf DGETNF
#define dlarfbut DLARFBUT
#define dlarfgut DLARFGUT
#define dlarftut DLARFTUT
#define sgelq2ut SGELQ2UT
#define sgelqfut SGELQFUT
#define sgeqr2ut SGEQR2UT
#define sgeqrfut SGEQRFUT
#define sgetn2 SGETN2
#define sgetnf SGETNF
#define slarfbut SLARFBUT
#define slarfgut SLARFGUT
#define slarftut SLARFTUT
#define zgelq2ut ZGELQ2UT
#define zgelqfut ZGELQFUT
#define zgeqr2ut ZGEQR2UT
#define zgeqrfut ZGEQRFUT
#define zgetn2 ZGETN2
#define zgetnf ZGETNF
#define zlarfbut ZLARFBUT
#define zlarfgut ZLARFGUT
#define zlarftut ZLARFTUT
